***************************************
* author Brunello Pulix
*        Cagliari (Italy)
*        brunellopulix@yahoo.it
*        placed in the public domain
***************************************
#include <hmg.ch>
#include <fileio.ch>
#include <common.ch>
*
# define OLE_DOC  0
# define OLE_HTML 8
# define OLE_DOCX 16
# define OLE_XML  11
# define OLE_PDF  17
# define OLE_XPS  18
*
Declare Window Main
*
Function GetImageFromRtf(cPath,cFile)
   Local nHandle
   Local aTemp
   Local i
   Local n1
   Local n2
   Local oFile
   *
   aTemp := {}
   n1    := 0
   n2    := 0
   *
   oFile := TFileRead():New( cPath+cFile+'.Rtf' )
   oFile:Open()
   DO WHILE oFile:MoreToRead()
      aadd(aTemp,oFile:ReadLine())
   ENDDO
   oFile:Close()
   *
   nHandle     := FCreate(cPath+cFile+'.Txt')
   For i := 1 To Len(aTemp)
      If '{\pict' $ aTemp[i]
         Fwrite(nHandle,Substr(aTemp[i],at('{\pict',aTemp[i]))+CRLF)
         n1 := i
         exit
      Endif
   Next
   *
   For i := n1+1 To Len(aTemp)
      If 'blabla' $ aTemp[i]
         aTemp[i] := left(aTemp[i],at('}}',aTemp[i]))
         if Substr(aTemp[i],Len(aTemp[i]),1) != '}'
            aTemp[i] += '}'
         endif
         Fwrite(nHandle,aTemp[i]+CRLF)
         exit
      Else
         Fwrite(nHandle,aTemp[i]+CRLF)
      endif
   Next
   FClose(nHandle)
   *
Return
*
Function ExtractWallpaperFromRtf(cPath,cFile)
   Local nHandle
   Local aTemp
   Local i
   Local n1
   Local n2
   Local oFile
   *
   aTemp := {}
   n1    := 0
   n2    := 0
   *
   oFile := TFileRead():New( cPath+cFile+'.Rtf' )
   oFile:Open()
   DO WHILE oFile:MoreToRead()
      aadd(aTemp,oFile:ReadLine())
   ENDDO
   oFile:Close()
   *
   nHandle     := FCreate(cPath+cFile+'.Txt')
   For i := 1 To Len(aTemp)
      If '{\*\generator' $ aTemp[i]
         Fwrite(nHandle,Substr(aTemp[i],at('{\*\generator',aTemp[i]))+CRLF)
         n1 := i
         exit
      Endif
   Next
   *
   n2 := Len(aTemp)
   For i := n1+1 To n2
      If i == n2
         aTemp[i] := left(aTemp[i],at('}}',aTemp[i]))
         if Substr(aTemp[i],Len(aTemp[i]),1) != '}'
            aTemp[i] += '}'
         endif
         Fwrite(nHandle,aTemp[i]+CRLF)
         exit
      Else
         Fwrite(nHandle,aTemp[i]+CRLF)
      endif
   Next
   FClose(nHandle)
   *
Return
*
Procedure RUN_WORD(cFile)
Local cOut
*
cFile := Upper(cFile)
If Main.RadioGroup_1.Value == 1
   // default rtf
elseIf Main.RadioGroup_1.Value == 2
   cOut   := StrTran(cFile,'.RTF','_DOC_.DOC')
   RUN_OLE(cFile,cOut,OLE_DOC)
   Ferase(cFile)
   cFile := cOut
elseIf Main.RadioGroup_1.Value == 3
   cOut   := StrTran(cFile,'.RTF','_HTML_.HTML')
   RUN_OLE(cFile,cOut,OLE_HTML)
   Ferase(cFile)
   cFile := cOut
elseIf Main.RadioGroup_1.Value == 4
   cOut   := StrTran(cFile,'.RTF','_DOCX_.DOCX')
   RUN_OLE(cFile,cOut,OLE_DOCX)
   Ferase(cFile)
   cFile := cOut
elseIf Main.RadioGroup_1.Value == 5
   cOut   := StrTran(cFile,'.RTF','_XML_.XML')
   RUN_OLE(cFile,cOut,OLE_XML)
   Ferase(cFile)
   cFile := cOut
elseIf Main.RadioGroup_1.Value == 6
   cOut   := StrTran(cFile,'.RTF','_PDF_.PDF')
   RUN_OLE(cFile,cOut,OLE_PDF)
   Ferase(cFile)
   cFile := cOut
elseIf Main.RadioGroup_1.Value == 7
   cOut   := StrTran(cFile,'.RTF','_XPS_.XPS')
   RUN_OLE(cFile,cOut,OLE_PDF)
   Ferase(cFile)
   cFile := cOut

Endif
*
*ShellExecute(,"Open",cFile,'',,0)
*ShellExecute(,"Open",'Winword',cFile,,0)
Execute file (cFile)
*
Return
*
Procedure RUN_OLE(cRtf,cOut,n)
Local oWord,oFile
*
WAIT WINDOW '.......Please wait......' NOWAIT
oWord := CreateObject( "Word.Application" )
oFile := oWord:Documents:Open(cRtf)
oFile:SaveAs(cOut,n)
oWord:quit()
WAIT CLEAR
*
Return
*


